// program klienta dodajacego
// (c) 2007 Kacper Kulczycki 

#include <stdio.h>
#include <unistd.h> 
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include "mesg_add.h"
#include "err.h"

int main()
{
  Mesg mesg;
  int id, BUF_LEN;
  BUF_LEN=sizeof(mesg);
  if ( (id = msgget(MKEY, 0)) == -1) // czy jest kolejka
	{
    	syserr("Klient: Blad w msgget!!!");
	}
  printf("Podaj liczby do dodania (calkowite):\nPierwsza liczba: ");
  if (scanf("%d",&mesg.data[0]) == 0)
 	{
    	syserr("Klient: Blad w scanf!!!");
	}
  printf("Druga liczba: ");
   if (scanf("%d",&mesg.data[1]) == 0)
        {
        syserr("Klient: Blad w scanf!!!");
        }
  printf("%d + %d = ", mesg.data[0], mesg.data[1]);
  mesg.mesg_type = 1L;	
  mesg.client_pid = (long) getpid(); 
  if (msgsnd(id, &mesg, BUF_LEN, 0) != 0) // wysylanie
    	{
	syserr("Klient: Blad w msgsnd!!!");
   	}
  if( msgrcv(id, &mesg, BUF_LEN, (long) getpid(), 0) < 1) // odbior
    	{
	syserr("Klient: Blad w msgrcv!!!");
	}
  else
	{	
	if (printf("%d\n",mesg.data[0]) < 0)
      		{
		syserr("Klient: Blad w printf!!!");
		}
  	}
  return 0;
}
