// plik serwera dodajacego
// (c) 2007 Kacper Kulczycki 

#include <stdio.h>
#include <unistd.h> 
#include <fcntl.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include "mesg_add.h"
#include "err.h"
 
int msg_qid;

void exit_server(int sig) 
{
  if (msgctl(msg_qid, IPC_RMID, 0) == -1) // kasowanie
	{
    	syserr("Serwer: Blad w msgctl RMID!!!");
	}
  exit(0);
}

int main()
{
  Mesg mesg;
  int  BUF_LEN;
  BUF_LEN=sizeof(mesg);	
  if (signal(SIGINT,  exit_server) == SIG_ERR)
	{
    	syserr("Serwer: Blad w signal!!!");
	}
  if ((msg_qid = msgget(MKEY, 0666 | IPC_CREAT | IPC_EXCL)) == -1) // tworzenie kolejki
    	{
	syserr("Serwer: Blad w msgget!!!");
	}
  for(;;) 
	{
    	if ((BUF_LEN = msgrcv(msg_qid, &mesg, BUF_LEN, 1L, 0)) < 1)  // odbior
      		{
		syserr("Serwer: Blad w msgrcv!!!");
		}
    	mesg.mesg_type = (long) mesg.client_pid;
    	mesg.data[0]= mesg.data[0]+mesg.data[1];  
     	if (msgsnd(msg_qid, &mesg, BUF_LEN, 0) != 0) // nadawanie
        	{
		syserr("Serwer: Blad w msgsnd!!!");
		} 
  	}
}
